@blamejs/pki 0.6.18 → 0.6.21
This diff represents the content of publicly available package versions that have been released to one of the supported registries. The information contained in this diff is provided for informational purposes only and reflects changes between package versions as they appear in their respective public registries.
- package/CHANGELOG.md +29 -0
- package/README.md +1 -1
- package/lib/acme.js +6 -6
- package/lib/cmp-build.js +10 -10
- package/lib/cms-encrypt.js +7 -7
- package/lib/key.js +1 -1
- package/lib/lint.js +5 -5
- package/lib/pbes2.js +1 -1
- package/lib/pkcs12-build.js +9 -9
- package/lib/scep.js +93 -17
- package/lib/schema-c509.js +10 -10
- package/lib/sign-scheme.js +2 -2
- package/lib/tsp-sign.js +4 -4
- package/lib/webcrypto.js +12 -12
- package/package.json +1 -1
- package/sbom.cdx.json +6 -6
package/CHANGELOG.md
CHANGED
|
@@ -4,6 +4,35 @@ All notable changes to `@blamejs/pki` are documented here. The format
|
|
|
4
4
|
follows [Keep a Changelog](https://keepachangelog.com/en/1.1.0/); this
|
|
5
5
|
project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).
|
|
6
6
|
|
|
7
|
+
## v0.6.21 — 2026-09-01
|
|
8
|
+
|
|
9
|
+
WebCrypto and the signing and format builders refuse an algorithm, curve, digest, or profile name that collides with an inherited Object.prototype property name.
|
|
10
|
+
|
|
11
|
+
### Fixed
|
|
12
|
+
|
|
13
|
+
- pki.webcrypto (generateKey, sign, verify, encrypt, decrypt, deriveBits, deriveKey, wrapKey, unwrapKey, importKey, encapsulateBits, decapsulateBits) refuses an algorithm name or namedCurve that collides with an inherited Object.prototype property name, returning webcrypto/not-supported instead of a bare Node error. The digest, PBMAC1 PRF, CMP body, PKCS#12 MAC hash, PBES2 PRF, and lint-profile lookups behind pki.tsp.sign, pki.cmp.build, pki.pkcs12.build, pki.key.encrypt, pki.lint.certificate, and the RSA-PSS and C509 builders are hardened the same way, each returning the verb's typed error for such a name.
|
|
14
|
+
|
|
15
|
+
## v0.6.20 — 2026-09-01
|
|
16
|
+
|
|
17
|
+
A vulnerable build-time dependency is refreshed; it is not part of the published package.
|
|
18
|
+
|
|
19
|
+
### Security
|
|
20
|
+
|
|
21
|
+
- browserslist, a transitive development dependency of the fuzzing harness, is updated from 4.28.4 to 4.28.8, clearing GHSA-73wf-gq98-2v4g and GHSA-c83g-rgw3-j3cx (both High). browserslist is a build-time and test-time dependency and is not part of the published package.
|
|
22
|
+
|
|
23
|
+
## v0.6.19 — 2026-09-01
|
|
24
|
+
|
|
25
|
+
pki.scep.build issues the CA-side CertRep response, so the toolkit produces the SCEP certification-authority reply the client enrollment verbs consume.
|
|
26
|
+
|
|
27
|
+
### Added
|
|
28
|
+
|
|
29
|
+
- pki.scep.build({ messageType: "CertRep", pkiStatus, transactionId, recipientNonce, ... }) issues a SCEP CertRep response (RFC 8894 sec. 3.3.2). SUCCESS takes certificates (and/or crls, leaf identified by content since the CMS certificate SET is DER-ordered) plus the requester's recipient certificate and the CA signer; the issued certificates ride a certs-only SignedData inside a pkcsPKIEnvelope encrypted to the requester. FAILURE takes a failInfo (and optional failInfoText) and PENDING takes neither; both omit the pkcsPKIEnvelope and are signed detached. recipientNonce (echoing the request's senderNonce) and transactionId are required; a missing failInfo on a FAILURE, a SUCCESS without a certificate/CRL or recipient, an envelope field on a FAILURE or PENDING, or an unknown pkiStatus or failInfo is refused with a typed scep/bad-input.
|
|
30
|
+
|
|
31
|
+
### Fixed
|
|
32
|
+
|
|
33
|
+
- An enumerated option whose value collides with an inherited Object.prototype property name, such as a pkiStatus, contentEncryptionAlgorithm, macAlgorithm, digestAlgorithm, PKCS#8 cipher, or ACME resource kind of "toString" or "constructor", is now refused with the verb's own typed bad-input error across pki.scep.build, pki.cms.encrypt, pki.cms.authenticate, pki.key.encrypt, pki.acme.validate, and pki.acme.assertTransition. Such a value previously resolved to the inherited method and the call surfaced an unrelated error, and pki.acme.validate accepted the kind and returned without checking any field.
|
|
34
|
+
- pki.scep.build now requires a primitive-string pkiStatus. A boxed String or an object that coerces to a status name is refused with scep/bad-input, instead of building a CertRep whose signed pkiStatus attribute claims SUCCESS while the pkcsPKIEnvelope that a SUCCESS response requires is absent.
|
|
35
|
+
|
|
7
36
|
## v0.6.18 — 2026-09-01
|
|
8
37
|
|
|
9
38
|
pki.cms.encrypt and pki.cms.decrypt envelope to and open a composite ML-KEM recipient, extending the CMS KEMRecipientInfo arm to the hybrid post-quantum key-establishment algorithms.
|
package/README.md
CHANGED
|
@@ -222,7 +222,7 @@ comment blocks, is at [pkijs.com](https://pkijs.com).
|
|
|
222
222
|
| `pki.schema.cmp` | CMP messages (RFC 9810): the header (version, sender and recipient including the anonymous NULL-DN, nonces, transaction id, general info), the 27-arm body (certificate requests via the CRMF parser, an encrypted certificate's EnvelopedData via CMS, response / revocation / confirmation / error / support / polling arms structural, the rest raw), and the exact `headerBytes` and `bodyBytes` slices an external verifier reconstructs the protected part from. The CMP-before-OCSP dispatch order is enforced Fail-closed — `parse`, `pemDecode`, `pemEncode` |
|
|
223
223
|
| `pki.schema.csrattrs` | EST CSR Attributes (`CsrAttrs`, RFC 8951 §3.5 / RFC 9908) — the `AttrOrOID` items a server sends to shape an enrollment: bare OIDs, attributes with raw values, and decoded views of the RFC 9908 meaningful types (extension requests, EC and RSA key-type conventions, the certification-request-info template). Unknown types are surfaced raw; structure and the RFC 9908 semantic MUSTs are fail-closed — `parse` |
|
|
224
224
|
| `pki.est` | Enrollment over Secure Transport (RFC 7030 / 8951 / 9908 / 7616). The client verbs `cacerts`, `simpleenroll`, `simplereenroll`, `serverkeygen`, `csrattrs`, and `fullcmc` drive the RFC 7030 flow over `pki.transport` (inject your own via `opts.transport`, or take the fail-closed default): HTTPS only, an explicit trust anchor required, same-origin redirects followed while a downgrade or loop is refused, a 202 Retry-After surfaced but never slept, HTTP Basic or Digest (RFC 7616, SHA-256 / SHA-512-256; MD5 and no-qop refused by default) answered only after the server is authenticated, and the issued certificate chosen by public-key match. `serverkeygen` requests a server-generated key, cleartext or an opaque CMS EnvelopedData, with encryption bound to the CSR's key-identifier attribute over a confidentiality-bearing cipher. `csrattrs` fetches the CA's RFC 9908 attributes policy. `fullcmc` (§4.3) carries a CMC Full PKI Request and reduces the CA's answer through `pki.cmc.verify` to one terminal outcome, refusing a response that fails to echo the transaction and nonce the request carried, or that covers a key the request never asked for; a certs-only reply to a bound request is refused rather than read as an issuance. Under the verbs sit the transport-agnostic codecs they compose: the RFC 8951 base64 transfer codec (which ignores Content-Transfer-Encoding), the `multipart/mixed` splitter, the certs-only and serverkeygen response validators over CMS, the enroll-attribute builders, and the HTTP response classifier — `transferDecode`/`transferEncode`, `parseCertsOnly`, `splitMultipartMixed`, `parseServerKeygenResponse`, `findIssuedCert`, `classifyResponse`, `paths`, and the builders |
|
|
225
|
-
| `pki.scep` | SCEP pkiMessage codec (RFC 8894), the client side of Simple Certificate Enrollment. `build(spec)` assembles a request: a `PKCSReq` or `RenewalReq` wraps a PKCS#10 certification request, whose own proof-of-possession it verifies first; a `CertPoll` wraps an IssuerAndSubject naming the issuing CA and the request subject; and a `GetCert` or `GetCRL` wraps an IssuerAndSerialNumber naming a certificate by its issuer and a positive serial of at most 20 octets. It encrypts the messageData to the CA as the inner EnvelopedData (`pkcsPKIEnvelope`, AES-128-CBC), and signs that under the transaction attributes RFC 8894 §3.2 defines, a messageType, a caller-unique transactionId, and a 16-byte senderNonce. The recipient CA certificate must assert `keyEncipherment`. `parse(bytes, opts?)` reads a `PKCSReq`, `RenewalReq`, `CertPoll`, `GetCert`, `GetCRL`, or `CertRep` back (a messageType outside the RFC 8894 registry is refused): it verifies the outer signature first and refuses a message whose signature does not check, so the transaction attributes it returns come only from a verified signer, never alongside a false verdict. Because a valid signature only proves self-consistency with the embedded certificate, pass `opts.signerCert` to authenticate a CA response against the CA certificate you hold (a public-key mismatch is refused, `signerAuthenticated` reports the result); a caller that omits it gets a crypto-only verdict and must authenticate the surfaced `signerCert` itself. It maps the messageType, pkiStatus, failInfo, and the nonces from their RFC 8894 enumerants and refuses an unknown one; given `recipientKey` it decrypts the `pkcsPKIEnvelope` to the messageData, and given `expectedSenderNonce` it refuses a response whose recipientNonce does not echo it. It reads a CA's CertRep in full. `getCACaps(baseUrl, opts?)`, `getCACert(baseUrl, opts?)`, `getNextCACert(baseUrl, opts)`, `enroll(baseUrl, opts)`, `renew(baseUrl, opts)`, `getCert(baseUrl, opts)`, and `getCrl(baseUrl, opts)` carry that codec to a live CA over HTTP (RFC 8894 §4) through an injectable transport (`pki.transport.https` by default): `getCACaps` reports the CA's advertised capabilities and never lowers the client's algorithm choice on the unauthenticated response, `getCACert` pins the CA certificate to an out-of-band `expectedFingerprint` a returned certificate must match, `getNextCACert` fetches the CA's next (rollover) certificate and verifies the SignedData response against the current CA certificate (`caCertificate`) before returning it, refusing a response signed by any other key, and `enroll` and `renew` POST a PKCSReq or RenewalReq, authenticate the CertRep against the CA certificate and its nonce echo, select the issued certificate by public-key match, throw on a FAILURE with the CA's failInfo, and poll a PENDING response with CertPoll requests until the CA answers or a bounded poll-count and total-wait budget is spent. `getCert` and `getCrl` retrieve an already-issued certificate or a CA CRL by issuer and serial number, authenticated the same way; RFC 8894 §2.6, §2.7, and §3.3.4 recommend these queries only where HTTP certificate-store access (RFC 4387), LDAP, or a CRL distribution point is unavailable, so prefer those where a CA offers them.
|
|
225
|
+
| `pki.scep` | SCEP pkiMessage codec (RFC 8894), the client side of Simple Certificate Enrollment. `build(spec)` assembles a request: a `PKCSReq` or `RenewalReq` wraps a PKCS#10 certification request, whose own proof-of-possession it verifies first; a `CertPoll` wraps an IssuerAndSubject naming the issuing CA and the request subject; and a `GetCert` or `GetCRL` wraps an IssuerAndSerialNumber naming a certificate by its issuer and a positive serial of at most 20 octets. It encrypts the messageData to the CA as the inner EnvelopedData (`pkcsPKIEnvelope`, AES-128-CBC), and signs that under the transaction attributes RFC 8894 §3.2 defines, a messageType, a caller-unique transactionId, and a 16-byte senderNonce. The recipient CA certificate must assert `keyEncipherment`. `build` also issues the CA-side `CertRep` response (§3.3.2): a SUCCESS envelopes a certs-only SignedData of the issued certificate (or the CRL for a GetCRL) to the requester and signs it under the CA key, while a FAILURE (carrying a `failInfo`) or a PENDING omits the pkcsPKIEnvelope and is signed detached, each echoing the request's senderNonce as `recipientNonce`. `parse(bytes, opts?)` reads a `PKCSReq`, `RenewalReq`, `CertPoll`, `GetCert`, `GetCRL`, or `CertRep` back (a messageType outside the RFC 8894 registry is refused): it verifies the outer signature first and refuses a message whose signature does not check, so the transaction attributes it returns come only from a verified signer, never alongside a false verdict. Because a valid signature only proves self-consistency with the embedded certificate, pass `opts.signerCert` to authenticate a CA response against the CA certificate you hold (a public-key mismatch is refused, `signerAuthenticated` reports the result); a caller that omits it gets a crypto-only verdict and must authenticate the surfaced `signerCert` itself. It maps the messageType, pkiStatus, failInfo, and the nonces from their RFC 8894 enumerants and refuses an unknown one; given `recipientKey` it decrypts the `pkcsPKIEnvelope` to the messageData, and given `expectedSenderNonce` it refuses a response whose recipientNonce does not echo it. It reads a CA's CertRep in full. `getCACaps(baseUrl, opts?)`, `getCACert(baseUrl, opts?)`, `getNextCACert(baseUrl, opts)`, `enroll(baseUrl, opts)`, `renew(baseUrl, opts)`, `getCert(baseUrl, opts)`, and `getCrl(baseUrl, opts)` carry that codec to a live CA over HTTP (RFC 8894 §4) through an injectable transport (`pki.transport.https` by default): `getCACaps` reports the CA's advertised capabilities and never lowers the client's algorithm choice on the unauthenticated response, `getCACert` pins the CA certificate to an out-of-band `expectedFingerprint` a returned certificate must match, `getNextCACert` fetches the CA's next (rollover) certificate and verifies the SignedData response against the current CA certificate (`caCertificate`) before returning it, refusing a response signed by any other key, and `enroll` and `renew` POST a PKCSReq or RenewalReq, authenticate the CertRep against the CA certificate and its nonce echo, select the issued certificate by public-key match, throw on a FAILURE with the CA's failInfo, and poll a PENDING response with CertPoll requests until the CA answers or a bounded poll-count and total-wait budget is spent. `getCert` and `getCrl` retrieve an already-issued certificate or a CA CRL by issuer and serial number, authenticated the same way; RFC 8894 §2.6, §2.7, and §3.3.4 recommend these queries only where HTTP certificate-store access (RFC 4387), LDAP, or a CRL distribution point is unavailable, so prefer those where a CA offers them. GET-carried PKIOperation and HTTP proxy authentication are not yet built — `build`, `parse`, `parseCapabilities`, `getCACaps`, `getCACert`, `getNextCACert`, `enroll`, `renew`, `getCert`, `getCrl` |
|
|
226
226
|
| `pki.transport` | The shared, fail-closed `node:https` transport the enrollment clients drive. `pki.transport.https(defaults)` returns a `transport(request) → { status, headers, body, tls }`, where `tls` carries the negotiated `protocol`, `cipher`, and raw `peerCertificate`. This is the toolkit's only socket choke point: an explicit trust anchor (or an opt-in to the system store) is required, `rejectUnauthorized` is always on, TLS is floored at 1.2, the response body is capped while it streams, and a stalled socket times out. The EST, ACME, and CMP clients reuse it verbatim. If you inject your own transport, return `tls` too: `pki.est.serverkeygen` asserts the negotiated cipher can protect the delivered private key, and a transport that reports no cipher is trusted rather than refused, so omitting the field silently skips that check — `https` |
|
|
227
227
|
| `pki.jose` | Flattened JWS (RFC 7515) and JWK thumbprints (RFC 7638). `sign` and `verify` run a Flattened JWS against declarative profiles (ACME outer, EAB inner, keyChange inner) that carry the required and forbidden header rules as data. `base64url` is the strict RFC 4648 §5 codec, rejecting padding, non-alphabet characters, and non-canonical trailing bits. `parseJson` is a bounded reader that refuses duplicate members at any depth. `thumbprint` is the RFC 7638 / 8037 / 9964 canonical digest. The algorithm registry binds each `alg` to its key type (ES/RS/PS/EdDSA/ML-DSA), leaving no code path for `alg:none`, an RS256→HS256 key confusion, or an all-zero ECDSA signature; `assertPublicJwk` refuses a JWK carrying private material, so an exported private key is never published. `opts.key` names the key a message must be signed under and governs: where the profile also permits an embedded header `jwk`, the two must be the same key — compared as RFC 7638 thumbprints, so member order cannot make equal keys differ — and a disagreement is refused rather than resolved in the message's favor. `keySource` reports which key answered, since a signature checked against a key you named is a different claim from one checked against the key the message carried — `sign`, `verify`, `base64url`, `parseJson`, `thumbprint`, `assertPublicJwk` |
|
|
228
228
|
| `pki.acme` | ACME (RFC 8555 / 8737 / 8738 / 9773). `client(directoryUrl, opts)` is a stateful client driving a live CA directory over `pki.transport`: `newAccount`, `newOrder`, `newAuthz`, `getOrder`, `getAuthorization`, `getChallenge`, `respondToChallenge`, `finalize`, `pollOrder`, `pollAuthorization`, and `downloadCertificate` walk the issuance flow, with `newAuthz` pre-authorizing a single identifier (§7.4.1) and `downloadCertificate` binding the issued certificate to the order — its key, its identifiers, or both; at least one is required by default and the result reports `boundToKey` / `boundToIdentifiers` — before choosing among alternate chains (`Link rel="alternate"`, §7.4.2, via a `selectChain` predicate bounded by `maxAlternates`). `revokeCert` (account-key or certificate-key signed), `keyChange`, `updateAccount` (change the account contacts, §7.3.2), `listOrders` (the account's orders list, following the §7.1.2.1 `Link rel="next"` pagination bounded by a page cap and confined to the orders origin), `deactivateAccount`, `deactivateAuthorization`, `renewalInfo` (ARI), and `renewalWindow` (the RFC 9773 §4.2/4.3 renewal decision) complete the lifecycle. Every URL is HTTPS only, an explicit trust anchor is required, each request carries a fresh single-use nonce with a bounded badNonce retry (and, when `opts.resignKeys` supplies caller-approved alternative account-key algorithms, a bounded RFC 8555 §6.2 badSignatureAlgorithm re-sign that the CA's advertised list can only filter, never widen, so it cannot force a weaker algorithm), reads are POST-as-GET, polling is bounded and sleeps on a Retry-After via an injectable sleeper capped by a poll count and a total-wait budget, and every response body is size-capped. The transport is injectable via `opts.transport`. Over the message layer it composes resource-object validators (closed status enums, conditional-required fields, unknown fields ignored), the three §7.1.6 state machines, the request builders (newAccount with External Account Binding, newOrder with `replaces`, finalize with a CSR identifier-set match and account-key-reuse rejection, challenge responses, deactivation, revokeCert in both key modes, the keyChange nested JWS, POST-as-GET), the http-01 / dns-01 / tls-alpn-01 challenge computations, the dns and ip identifier validators, and the ARI certID with serial sign-padding preserved — `client`, `validate`, `identify`, `assertTransition`, the builders, `keyAuthorization`, `http01`, `dns01`, `tlsAlpn01Extension`, `verifyTlsAlpn01`, `ariCertId` |
|
package/lib/acme.js
CHANGED
|
@@ -223,7 +223,7 @@ var STATUS = {
|
|
|
223
223
|
challenge: ["pending", "processing", "valid", "invalid"],
|
|
224
224
|
};
|
|
225
225
|
|
|
226
|
-
var SPECS = {
|
|
226
|
+
var SPECS = intrinsic.assign(intrinsic.create(null), {
|
|
227
227
|
directory: [
|
|
228
228
|
{ name: "newNonce", type: "url", required: true },
|
|
229
229
|
{ name: "newAccount", type: "url", required: true },
|
|
@@ -275,7 +275,7 @@ var SPECS = {
|
|
|
275
275
|
ordersList: [
|
|
276
276
|
{ name: "orders", type: "array", required: true, elemType: "url" },
|
|
277
277
|
],
|
|
278
|
-
};
|
|
278
|
+
});
|
|
279
279
|
|
|
280
280
|
function _checkType(kind, field, value, obj) {
|
|
281
281
|
switch (field.type) {
|
|
@@ -408,11 +408,11 @@ function _canonicalizeIpv6(value) {
|
|
|
408
408
|
}
|
|
409
409
|
|
|
410
410
|
|
|
411
|
-
var TRANSITIONS = {
|
|
411
|
+
var TRANSITIONS = intrinsic.assign(intrinsic.create(null), {
|
|
412
412
|
challenge: { pending: ["processing", "valid", "invalid"], processing: ["processing", "valid", "invalid"] },
|
|
413
413
|
authorization: { pending: ["valid", "invalid", "deactivated"], valid: ["expired", "deactivated", "revoked"] },
|
|
414
414
|
order: { pending: ["ready", "invalid"], ready: ["processing", "valid", "invalid"], processing: ["valid", "invalid"] },
|
|
415
|
-
};
|
|
415
|
+
});
|
|
416
416
|
|
|
417
417
|
/**
|
|
418
418
|
* @primitive pki.acme.assertTransition
|
|
@@ -434,7 +434,7 @@ function assertTransition(kind, from, to) {
|
|
|
434
434
|
var table = TRANSITIONS[kind];
|
|
435
435
|
if (!table) throw E("acme/bad-input", "unknown resource kind " + JSON.stringify(kind));
|
|
436
436
|
if (from === to) return;
|
|
437
|
-
var allowed = table[from];
|
|
437
|
+
var allowed = _hasOwn(table, from) ? table[from] : null;
|
|
438
438
|
if (!allowed || allowed.indexOf(to) === -1) throw E("acme/bad-transition", "illegal " + kind + " transition " + JSON.stringify(from) + " -> " + JSON.stringify(to) + " (RFC 8555 sec. 7.1.6)");
|
|
439
439
|
}
|
|
440
440
|
|
|
@@ -817,7 +817,7 @@ function newAccount(o) {
|
|
|
817
817
|
});
|
|
818
818
|
}
|
|
819
819
|
|
|
820
|
-
var _HMAC_HASH = { HS256: "SHA-256", HS384: "SHA-384", HS512: "SHA-512" };
|
|
820
|
+
var _HMAC_HASH = intrinsic.assign(intrinsic.create(null), { HS256: "SHA-256", HS384: "SHA-384", HS512: "SHA-512" });
|
|
821
821
|
|
|
822
822
|
/**
|
|
823
823
|
* @primitive pki.acme.externalAccountBinding
|
package/lib/cmp-build.js
CHANGED
|
@@ -75,18 +75,18 @@ var KNOWN_HEADER_KEYS = {
|
|
|
75
75
|
sender: 1, recipient: 1, pvno: 1, messageTime: 1, senderKID: 1, recipKID: 1,
|
|
76
76
|
transactionID: 1, senderNonce: 1, recipNonce: 1, freeText: 1, generalInfo: 1,
|
|
77
77
|
};
|
|
78
|
-
var KNOWN_BODY_KEYS = {
|
|
78
|
+
var KNOWN_BODY_KEYS = intrinsic.assign(intrinsic.create(null), {
|
|
79
79
|
ir: 1, cr: 1, kur: 1, krr: 1, ccr: 1, p10cr: 1, certConf: 1, pollReq: 1, genm: 1, rr: 1,
|
|
80
80
|
ip: 1, cp: 1, kup: 1, ccp: 1, krp: 1, rp: 1, genp: 1, error: 1, pollRep: 1, pkiconf: 1,
|
|
81
81
|
nested: 1,
|
|
82
|
-
};
|
|
83
|
-
var BODY_TAG = {
|
|
82
|
+
});
|
|
83
|
+
var BODY_TAG = intrinsic.assign(intrinsic.create(null), {
|
|
84
84
|
ir: 0, cr: 2, p10cr: 4, kur: 7, krr: 9, ccr: 13, rr: 11, genm: 21, certConf: 24, pollReq: 25,
|
|
85
85
|
ip: 1, cp: 3, kup: 8, krp: 10, rp: 12, ccp: 14, pkiconf: 19, genp: 22, error: 23, pollRep: 26,
|
|
86
86
|
nested: 20,
|
|
87
|
-
};
|
|
88
|
-
var CRMF_BODY = { ir: 1, cr: 1, kur: 1, krr: 1, ccr: 1 };
|
|
89
|
-
var CERT_REP_ARM = { ip: 1, cp: 1, kup: 1, ccp: 1 };
|
|
87
|
+
});
|
|
88
|
+
var CRMF_BODY = intrinsic.assign(intrinsic.create(null), { ir: 1, cr: 1, kur: 1, krr: 1, ccr: 1 });
|
|
89
|
+
var CERT_REP_ARM = intrinsic.assign(intrinsic.create(null), { ip: 1, cp: 1, kup: 1, ccp: 1 });
|
|
90
90
|
var KNOWN_OPTS_KEYS = { key: 1, cert: 1, mac: 1, extraCerts: 1, pem: 1, pss: 1, digestAlgorithm: 1 };
|
|
91
91
|
var KNOWN_OPTS_SIG_KEYS = { key: 1, cert: 1, extraCerts: 1, pem: 1, pss: 1, digestAlgorithm: 1 };
|
|
92
92
|
var KNOWN_OPTS_MAC_KEYS = { mac: 1, extraCerts: 1, pem: 1 };
|
|
@@ -100,17 +100,17 @@ var PBMAC1_DEFAULT_KEYLEN = 32;
|
|
|
100
100
|
var PBMAC1_MIN_KEYLEN = 20;
|
|
101
101
|
var PBMAC1_MAX_KEYLEN = 1024;
|
|
102
102
|
var PBMAC1_MIN_ITER = 1000;
|
|
103
|
-
var PBMAC1_PRF = { "SHA-256": "hmacWithSHA256", "SHA-384": "hmacWithSHA384", "SHA-512": "hmacWithSHA512" };
|
|
104
|
-
var PBMAC1_MAC_OID = { "SHA-256": "hmacWithSHA256", "SHA-384": "hmacWithSHA384", "SHA-512": "hmacWithSHA512" };
|
|
103
|
+
var PBMAC1_PRF = intrinsic.assign(intrinsic.create(null), { "SHA-256": "hmacWithSHA256", "SHA-384": "hmacWithSHA384", "SHA-512": "hmacWithSHA512" });
|
|
104
|
+
var PBMAC1_MAC_OID = intrinsic.assign(intrinsic.create(null), { "SHA-256": "hmacWithSHA256", "SHA-384": "hmacWithSHA384", "SHA-512": "hmacWithSHA512" });
|
|
105
105
|
var PBMAC1_PRF_HLEN = { "SHA-256": 32, "SHA-384": 48, "SHA-512": 64 };
|
|
106
106
|
var FAIL_INFO_NAMES = ["badAlg", "badMessageCheck", "badRequest", "badTime", "badCertId", "badDataFormat",
|
|
107
107
|
"wrongAuthority", "incorrectData", "missingTimeStamp", "badPOP", "certRevoked", "certConfirmed",
|
|
108
108
|
"wrongIntegrity", "badRecipientNonce", "timeNotAvailable", "unacceptedPolicy", "unacceptedExtension",
|
|
109
109
|
"addInfoNotAvailable", "badSenderNonce", "badCertTemplate", "signerNotTrusted", "transactionIdInUse",
|
|
110
110
|
"unsupportedVersion", "notAuthorized", "systemUnavail", "systemFailure", "duplicateCertReq"];
|
|
111
|
-
var FAIL_INFO_INDEX =
|
|
111
|
+
var FAIL_INFO_INDEX = intrinsic.create(null);
|
|
112
112
|
FAIL_INFO_NAMES.forEach(function (n, i) { FAIL_INFO_INDEX[n] = i; });
|
|
113
|
-
var CERT_CONF_HASH_ALGS = { sha1: 1, sha256: 1, sha384: 1, sha512: 1, "sha3-256": 1, "sha3-512": 1 };
|
|
113
|
+
var CERT_CONF_HASH_ALGS = intrinsic.assign(intrinsic.create(null), { sha1: 1, sha256: 1, sha384: 1, sha512: 1, "sha3-256": 1, "sha3-512": 1 });
|
|
114
114
|
|
|
115
115
|
|
|
116
116
|
function _reqOctets(v, what) {
|
package/lib/cms-encrypt.js
CHANGED
|
@@ -34,14 +34,14 @@ function _normCertDer(cert, what) {
|
|
|
34
34
|
throw _err("cms/bad-input", (what || "a certificate") + " must be a DER Buffer, Uint8Array, or PEM string");
|
|
35
35
|
}
|
|
36
36
|
|
|
37
|
-
var CONTENT_ALGS = {
|
|
37
|
+
var CONTENT_ALGS = intrinsic.assign(intrinsic.create(null), {
|
|
38
38
|
"aes-128-gcm": { oid: "aes128-GCM", keyBits: 128, aead: true },
|
|
39
39
|
"aes-192-gcm": { oid: "aes192-GCM", keyBits: 192, aead: true },
|
|
40
40
|
"aes-256-gcm": { oid: "aes256-GCM", keyBits: 256, aead: true },
|
|
41
41
|
"aes-128-cbc": { oid: "aes128-CBC", keyBits: 128, aead: false },
|
|
42
42
|
"aes-192-cbc": { oid: "aes192-CBC", keyBits: 192, aead: false },
|
|
43
43
|
"aes-256-cbc": { oid: "aes256-CBC", keyBits: 256, aead: false },
|
|
44
|
-
};
|
|
44
|
+
});
|
|
45
45
|
|
|
46
46
|
function _wrapOidForKek(keyBytes) {
|
|
47
47
|
if (keyBytes === 16) return "aes128-wrap";
|
|
@@ -83,7 +83,7 @@ function _assertKeyUsage(cert, bitName, arm) {
|
|
|
83
83
|
if (ku && ku[bitName] !== true) throw _err("cms/bad-key-usage", "the " + arm + " recipient certificate's keyUsage does not assert " + bitName);
|
|
84
84
|
}
|
|
85
85
|
|
|
86
|
-
var OAEP_HASH = { sha256: "SHA-256", sha384: "SHA-384", sha512: "SHA-512" };
|
|
86
|
+
var OAEP_HASH = intrinsic.assign(intrinsic.create(null), { sha256: "SHA-256", sha384: "SHA-384", sha512: "SHA-512" });
|
|
87
87
|
function _oaepParams(hashName) {
|
|
88
88
|
var hAlg = _algId(hashName, "null");
|
|
89
89
|
var mgf = b.sequence([b.oid(O("mgf1")), hAlg]);
|
|
@@ -282,7 +282,7 @@ function _pwriWrapIv(kek, cek, iv) {
|
|
|
282
282
|
}
|
|
283
283
|
}
|
|
284
284
|
|
|
285
|
-
var PRF_HASH = { hmacWithSHA1: "SHA-1", hmacWithSHA256: "SHA-256", hmacWithSHA384: "SHA-384", hmacWithSHA512: "SHA-512" };
|
|
285
|
+
var PRF_HASH = intrinsic.assign(intrinsic.create(null), { hmacWithSHA1: "SHA-1", hmacWithSHA256: "SHA-256", hmacWithSHA384: "SHA-384", hmacWithSHA512: "SHA-512" });
|
|
286
286
|
function _prfHash(prf) { if (!PRF_HASH[prf]) throw _err("cms/bad-input", "unsupported pwri prf " + JSON.stringify(prf)); return PRF_HASH[prf]; }
|
|
287
287
|
|
|
288
288
|
var _PWRI_KEYS = { password: 1, iterations: 1, prf: 1, salt: 1 };
|
|
@@ -557,13 +557,13 @@ function _tlvHeaderLen(der) {
|
|
|
557
557
|
}
|
|
558
558
|
|
|
559
559
|
|
|
560
|
-
var MAC_ALGS = {
|
|
560
|
+
var MAC_ALGS = intrinsic.assign(intrinsic.create(null), {
|
|
561
561
|
"hmac-sha256": { oid: "hmacWithSHA256", wc: "SHA-256", node: "sha256" },
|
|
562
562
|
"hmac-sha384": { oid: "hmacWithSHA384", wc: "SHA-384", node: "sha384" },
|
|
563
563
|
"hmac-sha512": { oid: "hmacWithSHA512", wc: "SHA-512", node: "sha512" },
|
|
564
|
-
};
|
|
564
|
+
});
|
|
565
565
|
var MAC_KEY_OCTETS = 32;
|
|
566
|
-
var SUPPORTED_DIGEST = { sha256: 1, sha384: 1, sha512: 1 };
|
|
566
|
+
var SUPPORTED_DIGEST = intrinsic.assign(intrinsic.create(null), { sha256: 1, sha384: 1, sha512: 1 });
|
|
567
567
|
|
|
568
568
|
async function authenticate(content, recipients, opts) {
|
|
569
569
|
opts = opts || {};
|
package/lib/key.js
CHANGED
|
@@ -36,7 +36,7 @@ var PemError = frameworkError.PemError;
|
|
|
36
36
|
function O(n) { return oid.byName(n); }
|
|
37
37
|
function _err(code, msg, cause) { return new KeyError(code, msg, cause); }
|
|
38
38
|
|
|
39
|
-
var CIPHER_NAME = { "aes-128-cbc": "aes128-CBC", "aes-192-cbc": "aes192-CBC", "aes-256-cbc": "aes256-CBC" };
|
|
39
|
+
var CIPHER_NAME = Object.assign(Object.create(null), { "aes-128-cbc": "aes128-CBC", "aes-192-cbc": "aes192-CBC", "aes-256-cbc": "aes256-CBC" });
|
|
40
40
|
|
|
41
41
|
var INFER_ALG = {};
|
|
42
42
|
["Ed25519", "Ed448", "X25519", "X448"].forEach(function (n) { INFER_ALG[O(n)] = { name: n }; });
|
package/lib/lint.js
CHANGED
|
@@ -44,7 +44,7 @@ var EXT_DECODERS = pkix.certExtensionDecoders(NS).byOid;
|
|
|
44
44
|
|
|
45
45
|
|
|
46
46
|
|
|
47
|
-
var SEVERITY = { fatal: 5, error: 4, warn: 3, notice: 2, pass: 1 };
|
|
47
|
+
var SEVERITY = Object.assign(Object.create(null), { fatal: 5, error: 4, warn: 3, notice: 2, pass: 1 });
|
|
48
48
|
var VALID_SEVERITY = Object.keys(SEVERITY);
|
|
49
49
|
|
|
50
50
|
function _worst(findings) {
|
|
@@ -191,7 +191,7 @@ function _rsaModulusBits(spki) {
|
|
|
191
191
|
return mod.toString(2).length;
|
|
192
192
|
} catch (_e) { return null; }
|
|
193
193
|
}
|
|
194
|
-
var RSA_KEY_ALGS = { rsaEncryption: 1, rsassaPss: 1, rsaesOaep: 1 };
|
|
194
|
+
var RSA_KEY_ALGS = Object.assign(Object.create(null), { rsaEncryption: 1, rsassaPss: 1, rsaesOaep: 1 });
|
|
195
195
|
var APPROVED_EC_CURVES = ["prime256v1", "secp384r1", "secp521r1"];
|
|
196
196
|
function _ecCurveName(spki) {
|
|
197
197
|
try {
|
|
@@ -476,7 +476,7 @@ var CABF_TLS_RULES = [
|
|
|
476
476
|
},
|
|
477
477
|
];
|
|
478
478
|
|
|
479
|
-
var ML_KEM_EK_LEN =
|
|
479
|
+
var ML_KEM_EK_LEN = Object.create(null);
|
|
480
480
|
["id-ml-kem-512", "id-ml-kem-768", "id-ml-kem-1024"].forEach(function (n) { ML_KEM_EK_LEN[n] = oid.kemParams(n).ek; });
|
|
481
481
|
function _isMlKem(cert) {
|
|
482
482
|
var spki = cert.subjectPublicKeyInfo;
|
|
@@ -510,11 +510,11 @@ var RFC9935_RULES = [
|
|
|
510
510
|
},
|
|
511
511
|
];
|
|
512
512
|
|
|
513
|
-
var PROFILES = {
|
|
513
|
+
var PROFILES = Object.assign(Object.create(null), {
|
|
514
514
|
"rfc5280": RFC5280_RULES,
|
|
515
515
|
"rfc9935": RFC9935_RULES,
|
|
516
516
|
"cabf-tls": CABF_TLS_RULES,
|
|
517
|
-
};
|
|
517
|
+
});
|
|
518
518
|
var ALL_RULES = RFC5280_RULES.concat(RFC9935_RULES).concat(CABF_TLS_RULES);
|
|
519
519
|
|
|
520
520
|
function _selectRules(profile) {
|
package/lib/pbes2.js
CHANGED
|
@@ -13,7 +13,7 @@ var C = require("./constants");
|
|
|
13
13
|
var b = asn1.build;
|
|
14
14
|
function O(n) { return oid.byName(n); }
|
|
15
15
|
|
|
16
|
-
var PRF_NODE_BY_NAME = { hmacWithSHA1: "sha1", hmacWithSHA256: "sha256", hmacWithSHA384: "sha384", hmacWithSHA512: "sha512" };
|
|
16
|
+
var PRF_NODE_BY_NAME = Object.assign(Object.create(null), { hmacWithSHA1: "sha1", hmacWithSHA256: "sha256", hmacWithSHA384: "sha384", hmacWithSHA512: "sha512" });
|
|
17
17
|
var PRF_NODE_BY_OID = {}; Object.keys(PRF_NODE_BY_NAME).forEach(function (n) { PRF_NODE_BY_OID[O(n)] = PRF_NODE_BY_NAME[n]; });
|
|
18
18
|
|
|
19
19
|
var CONTENT_KEYBITS = {}, CONTENT_MODE = {};
|
package/lib/pkcs12-build.js
CHANGED
|
@@ -51,18 +51,18 @@ var MAX_PBMAC1_KEYLEN = 1024;
|
|
|
51
51
|
var CLASSIC_MAC_MAX_ITERATIONS = 1000000;
|
|
52
52
|
var KDF_MAX_ROUNDS = CLASSIC_MAC_MAX_ITERATIONS;
|
|
53
53
|
|
|
54
|
-
var P12_KDF_UV = {
|
|
54
|
+
var P12_KDF_UV = intrinsic.assign(intrinsic.create(null), {
|
|
55
55
|
sha1: { u: 20, v: 64 }, sha224: { u: 28, v: 64 }, sha256: { u: 32, v: 64 },
|
|
56
56
|
sha384: { u: 48, v: 128 }, sha512: { u: 64, v: 128 },
|
|
57
|
-
};
|
|
58
|
-
var PBMAC1_PRF = {
|
|
57
|
+
});
|
|
58
|
+
var PBMAC1_PRF = intrinsic.assign(intrinsic.create(null), {
|
|
59
59
|
sha256: { prfName: "hmacWithSHA256", wc: "SHA-256", keyLen: 32 },
|
|
60
60
|
sha384: { prfName: "hmacWithSHA384", wc: "SHA-384", keyLen: 48 },
|
|
61
61
|
sha512: { prfName: "hmacWithSHA512", wc: "SHA-512", keyLen: 64 },
|
|
62
|
-
};
|
|
63
|
-
var PRF_WC = { hmacWithSHA1: "SHA-1", hmacWithSHA256: "SHA-256", hmacWithSHA384: "SHA-384", hmacWithSHA512: "SHA-512" };
|
|
64
|
-
var CIPHER_NAME = { "aes-128-cbc": "aes128-CBC", "aes-192-cbc": "aes192-CBC", "aes-256-cbc": "aes256-CBC" };
|
|
65
|
-
var DIGEST_NAME = { sha1: "sha1", sha256: "sha256", sha384: "sha384", sha512: "sha512" };
|
|
62
|
+
});
|
|
63
|
+
var PRF_WC = intrinsic.assign(intrinsic.create(null), { hmacWithSHA1: "SHA-1", hmacWithSHA256: "SHA-256", hmacWithSHA384: "SHA-384", hmacWithSHA512: "SHA-512" });
|
|
64
|
+
var CIPHER_NAME = intrinsic.assign(intrinsic.create(null), { "aes-128-cbc": "aes128-CBC", "aes-192-cbc": "aes192-CBC", "aes-256-cbc": "aes256-CBC" });
|
|
65
|
+
var DIGEST_NAME = intrinsic.assign(intrinsic.create(null), { sha1: "sha1", sha256: "sha256", sha384: "sha384", sha512: "sha512" });
|
|
66
66
|
|
|
67
67
|
|
|
68
68
|
|
|
@@ -77,14 +77,14 @@ var _BUILD_OPTS_SHORTHAND = { integrity: 1, mac: 1, password: 1, pem: 1, recipie
|
|
|
77
77
|
var _SAFE_RECIPIENTS_KEYS = { bags: 1, recipients: 1, contentEncryptionAlgorithm: 1 };
|
|
78
78
|
var _SAFE_PASSWORD_KEYS = { bags: 1, encrypt: 1 };
|
|
79
79
|
var _SAFE_PLAINTEXT_KEYS = { bags: 1 };
|
|
80
|
-
var _BAG_KEYS_BY_TYPE = {
|
|
80
|
+
var _BAG_KEYS_BY_TYPE = intrinsic.assign(intrinsic.create(null), {
|
|
81
81
|
key: { type: 1, friendlyName: 1, localKeyId: 1, key: 1 },
|
|
82
82
|
shroudedKey: { type: 1, friendlyName: 1, localKeyId: 1, key: 1, encrypt: 1 },
|
|
83
83
|
cert: { type: 1, friendlyName: 1, localKeyId: 1, cert: 1 },
|
|
84
84
|
crl: { type: 1, friendlyName: 1, localKeyId: 1, crl: 1 },
|
|
85
85
|
secret: { type: 1, friendlyName: 1, localKeyId: 1, secretTypeId: 1, secretValue: 1 },
|
|
86
86
|
safeContents: { type: 1, friendlyName: 1, localKeyId: 1, nested: 1 },
|
|
87
|
-
};
|
|
87
|
+
});
|
|
88
88
|
var _ENCRYPT_KEYS = { password: 1, cipher: 1, salt: 1, iterations: 1, prf: 1 };
|
|
89
89
|
var _MAC_KEYS = { algorithm: 1, hash: 1, salt: 1, iterations: 1, keyLength: 1, password: 1 };
|
|
90
90
|
var _MAC_KEYS_HMAC = { algorithm: 1, hash: 1, salt: 1, iterations: 1, password: 1 };
|
package/lib/scep.js
CHANGED
|
@@ -16,8 +16,8 @@
|
|
|
16
16
|
* outer SignedData that signs it under a set of authenticated transaction
|
|
17
17
|
* attributes -- messageType, transactionID, pkiStatus, failInfo, and the
|
|
18
18
|
* sender/recipient nonces (RFC 8894 sec. 3). `pki.scep.build` assembles a
|
|
19
|
-
* request pkiMessage (PKCSReq, RenewalReq, CertPoll, GetCert, or GetCRL)
|
|
20
|
-
* `pki.scep.parse` verifies the
|
|
19
|
+
* request pkiMessage (PKCSReq, RenewalReq, CertPoll, GetCert, or GetCRL) or a
|
|
20
|
+
* CA-side CertRep response; `pki.scep.parse` verifies the
|
|
21
21
|
* outer signature, reads the transaction attributes BOUND to the verified
|
|
22
22
|
* signer, and (given the recipient key) decrypts the pkcsPKIEnvelope to the
|
|
23
23
|
* messageData.
|
|
@@ -29,10 +29,10 @@
|
|
|
29
29
|
* pki.transport separately.
|
|
30
30
|
*
|
|
31
31
|
* @card
|
|
32
|
-
* Build and read SCEP (RFC 8894)
|
|
33
|
-
*
|
|
34
|
-
* layering, and any of
|
|
35
|
-
* attributes and decrypted messageData.
|
|
32
|
+
* Build and read SCEP (RFC 8894) messages: a PKCSReq, RenewalReq, CertPoll,
|
|
33
|
+
* GetCert, or GetCRL request, or a CA-side CertRep response, wrapped in the
|
|
34
|
+
* signed-over-encrypted CMS layering, and any of them parsed back to its verified
|
|
35
|
+
* transaction attributes and decrypted messageData.
|
|
36
36
|
*/
|
|
37
37
|
|
|
38
38
|
var frameworkError = require("./framework-error");
|
|
@@ -63,14 +63,14 @@ function _err(code, msg, cause) { return new ScepError(code, msg, cause); }
|
|
|
63
63
|
|
|
64
64
|
var _KU_NS = pkix.makeNS("scep", ScepError, oid);
|
|
65
65
|
|
|
66
|
-
var MESSAGE_TYPE = { CertRep: "3", RenewalReq: "17", PKCSReq: "19", CertPoll: "20", GetCert: "21", GetCRL: "22" };
|
|
67
|
-
var PKI_STATUS = { SUCCESS: "0", FAILURE: "2", PENDING: "3" };
|
|
68
|
-
var FAIL_INFO = { badAlg: "0", badMessageCheck: "1", badRequest: "2", badTime: "3", badCertId: "4" };
|
|
66
|
+
var MESSAGE_TYPE = Object.assign(Object.create(null), { CertRep: "3", RenewalReq: "17", PKCSReq: "19", CertPoll: "20", GetCert: "21", GetCRL: "22" });
|
|
67
|
+
var PKI_STATUS = Object.assign(Object.create(null), { SUCCESS: "0", FAILURE: "2", PENDING: "3" });
|
|
68
|
+
var FAIL_INFO = Object.assign(Object.create(null), { badAlg: "0", badMessageCheck: "1", badRequest: "2", badTime: "3", badCertId: "4" });
|
|
69
69
|
|
|
70
70
|
function _invert(table) { var o = Object.create(null); for (var k in table) if (Object.prototype.hasOwnProperty.call(table, k)) o[table[k]] = k; return o; }
|
|
71
71
|
var MESSAGE_TYPE_BY_CODE = _invert(MESSAGE_TYPE), PKI_STATUS_BY_CODE = _invert(PKI_STATUS), FAIL_INFO_BY_CODE = _invert(FAIL_INFO);
|
|
72
72
|
|
|
73
|
-
var _PARSE_SUPPORTED = { PKCSReq: 1, RenewalReq: 1, CertRep: 1, CertPoll: 1, GetCert: 1, GetCRL: 1 };
|
|
73
|
+
var _PARSE_SUPPORTED = Object.assign(Object.create(null), { PKCSReq: 1, RenewalReq: 1, CertRep: 1, CertPoll: 1, GetCert: 1, GetCRL: 1 });
|
|
74
74
|
|
|
75
75
|
var ENVELOPE_CIPHER = "aes-128-cbc";
|
|
76
76
|
|
|
@@ -225,16 +225,26 @@ function _captureRecipientKey(rk) {
|
|
|
225
225
|
* CA-issued certificate instead, which is why this is the caller's choice rather than an enforced
|
|
226
226
|
* match. The proof-of-possession over the PKCS#10 itself is verified regardless.
|
|
227
227
|
*
|
|
228
|
+
* A `CertRep` response is the CA (responder) side: it carries the transaction `pkiStatus`, echoes the
|
|
229
|
+
* request's senderNonce as `recipientNonce`, and is signed under the CA's `signer`. A SUCCESS response
|
|
230
|
+
* envelopes a certs-only SignedData of the issued `certificates` (or the `crls` of a GetCRL response) to
|
|
231
|
+
* the requester's `recipient` certificate; a FAILURE (which carries a `failInfo`) or a PENDING response
|
|
232
|
+
* omits the pkcsPKIEnvelope and is signed detached (RFC 8894 sec. 3.3.2).
|
|
233
|
+
*
|
|
228
234
|
* @opts
|
|
229
|
-
* - `messageType` -- "PKCSReq" | "RenewalReq" | "CertPoll" | "GetCert" | "GetCRL".
|
|
235
|
+
* - `messageType` -- "PKCSReq" | "RenewalReq" | "CertPoll" | "GetCert" | "GetCRL" | "CertRep".
|
|
230
236
|
* - `messageData` -- the PKCS#10 CertificationRequest DER, for a PKCSReq or RenewalReq.
|
|
231
237
|
* - `requestSubject` -- the request subject Name DER, for a CertPoll.
|
|
232
238
|
* - `certificate` -- for a GetCert or GetCRL, the certificate DER whose issuer and serial name the target (the convenience form).
|
|
233
239
|
* - `issuer` / `serialNumber` -- for a GetCert or GetCRL, the issuer Name DER and a positive serial (a BigInt, number, or hex string) naming the target directly. For a CertPoll, `issuer` alone names the issuing CA (defaulting to the recipient's subject) when the request is encrypted to a separate RA.
|
|
234
|
-
* - `recipient` -- the
|
|
235
|
-
* - `signer` -- `{ cert, key }`, the outer SignedData signer (the client for a request).
|
|
236
|
-
* - `transactionId` -- a caller-unique PrintableString identifying the transaction.
|
|
240
|
+
* - `recipient` -- the certificate DER the pkcsPKIEnvelope is encrypted to (an RSA key-transport certificate; a non-RSA recipient is refused, since the envelope uses RSAES-OAEP): the CA or RA certificate for a request, the requester's certificate for a SUCCESS CertRep.
|
|
241
|
+
* - `signer` -- `{ cert, key }`, the outer SignedData signer (the client for a request, the CA for a CertRep).
|
|
242
|
+
* - `transactionId` -- a caller-unique PrintableString identifying the transaction (echoes the request's on a CertRep).
|
|
237
243
|
* - `senderNonce` -- a 16-byte Buffer (generated when omitted).
|
|
244
|
+
* - `pkiStatus` -- for a CertRep, "SUCCESS" | "FAILURE" | "PENDING".
|
|
245
|
+
* - `recipientNonce` -- for a CertRep, the 16-byte value echoing the request's senderNonce (required).
|
|
246
|
+
* - `certificates` / `crls` -- for a SUCCESS CertRep, arrays of the issued certificate DER (or CRL DER) the certs-only SignedData carries.
|
|
247
|
+
* - `failInfo` / `failInfoText` -- for a FAILURE CertRep, the failInfo (badAlg / badMessageCheck / badRequest / badTime / badCertId) and an optional detail string.
|
|
238
248
|
* @example
|
|
239
249
|
* // requires: csrDer -- the PKCS#10 CertificationRequest DER to enrol
|
|
240
250
|
* // requires: caCertDer -- the SCEP CA (or RA) certificate the request is encrypted to (keyEncipherment)
|
|
@@ -246,11 +256,15 @@ function _captureRecipientKey(rk) {
|
|
|
246
256
|
*/
|
|
247
257
|
async function build(spec) {
|
|
248
258
|
spec = guard.identifier.optionsObject(spec, _err, "scep/bad-input", "pki.scep.build spec");
|
|
249
|
-
guard.identifier.assertKnownKeys(spec, _BUILD_KEYS, _err, "scep/bad-input", "pki.scep.build has an unknown option: ");
|
|
250
259
|
var mtCode = MESSAGE_TYPE[spec.messageType];
|
|
251
260
|
if (mtCode == null) throw _err("scep/bad-message-type", "unknown messageType " + JSON.stringify(spec.messageType) + " (RFC 8894 sec. 3.2.1.2)");
|
|
261
|
+
if (spec.messageType === "CertRep") {
|
|
262
|
+
guard.identifier.assertKnownKeys(spec, _CERTREP_KEYS, _err, "scep/bad-input", "pki.scep.build (CertRep) has an unknown option: ");
|
|
263
|
+
return await _buildCertRep(spec);
|
|
264
|
+
}
|
|
265
|
+
guard.identifier.assertKnownKeys(spec, _REQUEST_KEYS, _err, "scep/bad-input", "pki.scep.build has an unknown option: ");
|
|
252
266
|
if (spec.messageType !== "PKCSReq" && spec.messageType !== "RenewalReq" && spec.messageType !== "CertPoll" && spec.messageType !== "GetCert" && spec.messageType !== "GetCRL") {
|
|
253
|
-
throw _err("scep/bad-message-type", "pki.scep.build issues a request (PKCSReq / RenewalReq / CertPoll / GetCert / GetCRL); " + spec.messageType + " is not built in this release");
|
|
267
|
+
throw _err("scep/bad-message-type", "pki.scep.build issues a request (PKCSReq / RenewalReq / CertPoll / GetCert / GetCRL) or a CertRep response; " + spec.messageType + " is not built in this release");
|
|
254
268
|
}
|
|
255
269
|
if (spec.signer == null || typeof spec.signer !== "object") throw _err("scep/bad-input", "a signer { cert, key } is required");
|
|
256
270
|
var senderNonce = _nonce(spec.senderNonce, "senderNonce");
|
|
@@ -293,7 +307,69 @@ async function build(spec) {
|
|
|
293
307
|
throw e;
|
|
294
308
|
}
|
|
295
309
|
}
|
|
296
|
-
var
|
|
310
|
+
var _REQUEST_KEYS = { messageType: 1, messageData: 1, recipient: 1, requestSubject: 1, issuer: 1, certificate: 1, serialNumber: 1, signer: 1, transactionId: 1, senderNonce: 1 };
|
|
311
|
+
var _CERTREP_KEYS = { messageType: 1, signer: 1, transactionId: 1, senderNonce: 1, pkiStatus: 1, recipientNonce: 1, certificates: 1, crls: 1, recipient: 1, failInfo: 1, failInfoText: 1 };
|
|
312
|
+
|
|
313
|
+
async function _buildCertRep(spec) {
|
|
314
|
+
if (spec.signer == null || typeof spec.signer !== "object") throw _err("scep/bad-input", "a signer { cert, key } is required");
|
|
315
|
+
if (typeof spec.pkiStatus !== "string") throw _err("scep/bad-input", "a CertRep pkiStatus must be SUCCESS, FAILURE, or PENDING (RFC 8894 sec. 3.2.1.3), got " + JSON.stringify(spec.pkiStatus));
|
|
316
|
+
var statusCode = PKI_STATUS[spec.pkiStatus];
|
|
317
|
+
if (statusCode == null) throw _err("scep/bad-input", "a CertRep pkiStatus must be SUCCESS, FAILURE, or PENDING (RFC 8894 sec. 3.2.1.3), got " + JSON.stringify(spec.pkiStatus));
|
|
318
|
+
var txnId = _transactionId(spec.transactionId);
|
|
319
|
+
if (spec.recipientNonce == null) throw _err("scep/bad-input", "a CertRep must echo the request's senderNonce as recipientNonce (RFC 8894 sec. 3.2.1.5)");
|
|
320
|
+
var recipientNonce = _nonce(spec.recipientNonce, "recipientNonce");
|
|
321
|
+
var senderNonce = _nonce(spec.senderNonce, "senderNonce");
|
|
322
|
+
var signerCert = guard.bytes.snapshotSource(spec.signer.cert, ScepError, "scep/bad-input", "signer.cert");
|
|
323
|
+
var signerKey = spec.signer.key;
|
|
324
|
+
_assertSigningKeyUsage(signerCert, "signer certificate");
|
|
325
|
+
var attrs = [
|
|
326
|
+
_attr("scepMessageType", b.printable(MESSAGE_TYPE.CertRep)),
|
|
327
|
+
_attr("scepTransactionId", b.printable(txnId)),
|
|
328
|
+
_attr("scepSenderNonce", b.octetString(senderNonce)),
|
|
329
|
+
_attr("scepPkiStatus", b.printable(statusCode)),
|
|
330
|
+
_attr("scepRecipientNonce", b.octetString(recipientNonce)),
|
|
331
|
+
];
|
|
332
|
+
if (spec.pkiStatus !== "FAILURE" && (spec.failInfo != null || spec.failInfoText != null)) {
|
|
333
|
+
throw _err("scep/bad-input", "failInfo and failInfoText are only valid on a FAILURE CertRep (RFC 8894 sec. 3.2.1.4)");
|
|
334
|
+
}
|
|
335
|
+
var content = null;
|
|
336
|
+
if (spec.pkiStatus === "SUCCESS") {
|
|
337
|
+
var certs = spec.certificates != null ? spec.certificates : [];
|
|
338
|
+
var crls = spec.crls != null ? spec.crls : [];
|
|
339
|
+
if (!Array.isArray(certs) || !Array.isArray(crls)) throw _err("scep/bad-input", "a CertRep certificates and crls must be arrays of certificate / CRL DER");
|
|
340
|
+
if (certs.length === 0 && crls.length === 0) throw _err("scep/bad-input", "a SUCCESS CertRep must carry at least one certificate or CRL (RFC 8894 sec. 3.3.2.1)");
|
|
341
|
+
if (spec.recipient == null) throw _err("scep/bad-input", "a SUCCESS CertRep needs a recipient certificate to encrypt the pkcsPKIEnvelope to (RFC 8894 sec. 3.2.2)");
|
|
342
|
+
var recipient = guard.bytes.snapshotSource(spec.recipient, ScepError, "scep/bad-input", "recipient");
|
|
343
|
+
_assertRsaRecipient(recipient);
|
|
344
|
+
var certsOnlyDer;
|
|
345
|
+
try { certsOnlyDer = cmsSign.certsOnly(certs, { crls: crls }); }
|
|
346
|
+
catch (e) { throw _err("scep/bad-input", "a SUCCESS CertRep certificates / crls must be valid certificate / CRL DER (RFC 8894 sec. 3.4): " + e.message, e); }
|
|
347
|
+
try { content = await cmsEncrypt.encrypt(certsOnlyDer, [{ cert: recipient }], { contentEncryptionAlgorithm: ENVELOPE_CIPHER }); }
|
|
348
|
+
catch (e) {
|
|
349
|
+
if (e && e.isPkiError) throw _err("scep/bad-input", "the SUCCESS CertRep pkcsPKIEnvelope could not be built (the recipient must be a keyEncipherment certificate): " + e.message, e);
|
|
350
|
+
throw e;
|
|
351
|
+
}
|
|
352
|
+
} else {
|
|
353
|
+
if (spec.certificates != null || spec.crls != null || spec.recipient != null) {
|
|
354
|
+
throw _err("scep/bad-input", "a " + spec.pkiStatus + " CertRep must omit certificates, crls, and recipient: the pkcsPKIEnvelope is omitted (RFC 8894 sec. 3.3.2." + (spec.pkiStatus === "FAILURE" ? "2" : "3") + ")");
|
|
355
|
+
}
|
|
356
|
+
if (spec.pkiStatus === "FAILURE") {
|
|
357
|
+
var failCode = FAIL_INFO[spec.failInfo];
|
|
358
|
+
if (failCode == null) throw _err("scep/bad-input", "a FAILURE CertRep must carry a failInfo of badAlg / badMessageCheck / badRequest / badTime / badCertId (RFC 8894 sec. 3.2.1.4), got " + JSON.stringify(spec.failInfo));
|
|
359
|
+
attrs.push(_attr("scepFailInfo", b.printable(failCode)));
|
|
360
|
+
if (spec.failInfoText != null) attrs.push(_attr("scepFailInfoText", b.utf8(String(spec.failInfoText))));
|
|
361
|
+
}
|
|
362
|
+
}
|
|
363
|
+
var signOpts = { additionalSignedAttributes: attrs };
|
|
364
|
+
var signContent = content;
|
|
365
|
+
if (content == null) { signContent = Buffer.alloc(0); signOpts.detached = true; }
|
|
366
|
+
try {
|
|
367
|
+
return await cmsSign.sign(signContent, { cert: signerCert, key: signerKey }, signOpts);
|
|
368
|
+
} catch (e) {
|
|
369
|
+
if (e && e.isPkiError) throw _err("scep/bad-input", "the CertRep could not be signed: " + e.message, e);
|
|
370
|
+
throw e;
|
|
371
|
+
}
|
|
372
|
+
}
|
|
297
373
|
|
|
298
374
|
function _buildIssuerAndSubject(recipientCertDer, requestSubjectSource, issuerOverride) {
|
|
299
375
|
var subject = guard.bytes.snapshotSource(requestSubjectSource, ScepError, "scep/bad-input", "requestSubject");
|
package/lib/schema-c509.js
CHANGED
|
@@ -47,7 +47,7 @@ var PK_ALG_BY_INT = {
|
|
|
47
47
|
2: { alg: _name("ecPublicKey"), curve: _name("secp384r1") },
|
|
48
48
|
3: { alg: _name("ecPublicKey"), curve: _name("secp521r1") },
|
|
49
49
|
};
|
|
50
|
-
var EC_FIELD_BYTES = { "prime256v1": 32, "secp384r1": 48, "secp521r1": 66 };
|
|
50
|
+
var EC_FIELD_BYTES = Object.assign(Object.create(null), { "prime256v1": 32, "secp384r1": 48, "secp521r1": 66 });
|
|
51
51
|
|
|
52
52
|
var ATTR_BY_INT = {
|
|
53
53
|
0: _name("emailAddress"),
|
|
@@ -87,14 +87,14 @@ var EXT_BY_INT = {
|
|
|
87
87
|
36: _name("ocspNoCheck"),
|
|
88
88
|
38: _name("tlsFeature"),
|
|
89
89
|
};
|
|
90
|
-
var EXT_COMPACT = {
|
|
90
|
+
var EXT_COMPACT = Object.assign(Object.create(null), {
|
|
91
91
|
subjectKeyIdentifier: 1, keyUsage: 1, basicConstraints: 1, authorityKeyIdentifier: 1,
|
|
92
92
|
extKeyUsage: 1, inhibitAnyPolicy: 1, ocspNoCheck: 1, tlsFeature: 1,
|
|
93
93
|
subjectAltName: 1, issuerAltName: 1, nameConstraints: 1, cRLDistributionPoints: 1,
|
|
94
94
|
freshestCRL: 1, authorityInfoAccess: 1, subjectInfoAccess: 1, certificatePolicies: 1,
|
|
95
95
|
policyMappings: 1, policyConstraints: 1, subjectDirectoryAttributes: 1,
|
|
96
96
|
ipAddrBlocks: 1, autonomousSysIds: 1, ipAddrBlocksV2: 1, autonomousSysIdsV2: 1,
|
|
97
|
-
};
|
|
97
|
+
});
|
|
98
98
|
var EKU_BY_INT = {
|
|
99
99
|
0: _name("anyExtendedKeyUsage"), 1: _name("serverAuth"), 2: _name("clientAuth"),
|
|
100
100
|
3: _name("codeSigning"), 4: _name("emailProtection"), 8: _name("timeStamping"), 9: _name("ocspSigning"),
|
|
@@ -1561,11 +1561,11 @@ function matches(node) {
|
|
|
1561
1561
|
}
|
|
1562
1562
|
|
|
1563
1563
|
|
|
1564
|
-
var SIG_ALG_TO_INT = { ecdsaWithSHA256: 0, ecdsaWithSHA384: 1, ecdsaWithSHA512: 2 };
|
|
1565
|
-
var PK_ALG_TO_INT = { rsaEncryption: 0, "ecPublicKey|prime256v1": 1, "ecPublicKey|secp384r1": 2, "ecPublicKey|secp521r1": 3 };
|
|
1566
|
-
var ATTR_TO_INT =
|
|
1564
|
+
var SIG_ALG_TO_INT = Object.assign(Object.create(null), { ecdsaWithSHA256: 0, ecdsaWithSHA384: 1, ecdsaWithSHA512: 2 });
|
|
1565
|
+
var PK_ALG_TO_INT = Object.assign(Object.create(null), { rsaEncryption: 0, "ecPublicKey|prime256v1": 1, "ecPublicKey|secp384r1": 2, "ecPublicKey|secp521r1": 3 });
|
|
1566
|
+
var ATTR_TO_INT = Object.create(null);
|
|
1567
1567
|
Object.keys(ATTR_BY_INT).forEach(function (k) { ATTR_TO_INT[ATTR_BY_INT[k]] = Number(k); });
|
|
1568
|
-
var EXT_TO_INT =
|
|
1568
|
+
var EXT_TO_INT = Object.create(null);
|
|
1569
1569
|
Object.keys(EXT_BY_INT).forEach(function (k) { if (EXT_COMPACT[EXT_BY_INT[k]]) EXT_TO_INT[EXT_BY_INT[k]] = Number(k); });
|
|
1570
1570
|
|
|
1571
1571
|
function _minBytes(n) {
|
|
@@ -1754,9 +1754,9 @@ function _keyUsageBitsFromDer(extnValue) {
|
|
|
1754
1754
|
return _namedBitsFromContent(bs.bytes, bs.unusedBits);
|
|
1755
1755
|
}
|
|
1756
1756
|
var _NO_EXPIRY = Date.UTC(9999, 11, 31, 23, 59, 59);
|
|
1757
|
-
var NODE_TO_WEBCRYPTO = { "prime256v1": "P-256", "secp384r1": "P-384", "secp521r1": "P-521" };
|
|
1758
|
-
var WEBCRYPTO_FIELD_BYTES = { "P-256": 32, "P-384": 48, "P-521": 66 };
|
|
1759
|
-
var SIG_ALG_TO_CURVE = { "ecdsaWithSHA256": "P-256", "ecdsaWithSHA384": "P-384", "ecdsaWithSHA512": "P-521" };
|
|
1757
|
+
var NODE_TO_WEBCRYPTO = Object.assign(Object.create(null), { "prime256v1": "P-256", "secp384r1": "P-384", "secp521r1": "P-521" });
|
|
1758
|
+
var WEBCRYPTO_FIELD_BYTES = Object.assign(Object.create(null), { "P-256": 32, "P-384": 48, "P-521": 66 });
|
|
1759
|
+
var SIG_ALG_TO_CURVE = Object.assign(Object.create(null), { "ecdsaWithSHA256": "P-256", "ecdsaWithSHA384": "P-384", "ecdsaWithSHA512": "P-521" });
|
|
1760
1760
|
function _magBytes(intNode) {
|
|
1761
1761
|
var c = intNode.content, i = 0;
|
|
1762
1762
|
while (i < c.length - 1 && c[i] === 0x00) i++;
|
package/lib/sign-scheme.js
CHANGED
|
@@ -24,8 +24,8 @@ var _isBuffer = intrinsic.isBuffer;
|
|
|
24
24
|
var _bufferFrom = intrinsic.bufferFrom;
|
|
25
25
|
var _isU8 = intrinsic.types.isUint8Array;
|
|
26
26
|
|
|
27
|
-
var HASH = { sha256: "SHA-256", sha384: "SHA-384", sha512: "SHA-512" };
|
|
28
|
-
var NODE_DIGEST = { sha256: "sha256", sha384: "sha384", sha512: "sha512", shake128: "shake128", shake256: "shake256" };
|
|
27
|
+
var HASH = intrinsic.assign(intrinsic.create(null), { sha256: "SHA-256", sha384: "SHA-384", sha512: "SHA-512" });
|
|
28
|
+
var NODE_DIGEST = intrinsic.assign(intrinsic.create(null), { sha256: "sha256", sha384: "sha384", sha512: "sha512", shake128: "shake128", shake256: "shake256" });
|
|
29
29
|
var PSS_SALT = { "SHA-256": 32, "SHA-384": 48, "SHA-512": 64 };
|
|
30
30
|
var ECDSA_ALG = { sha256: "ecdsaWithSHA256", sha384: "ecdsaWithSHA384", sha512: "ecdsaWithSHA512" };
|
|
31
31
|
var RSA_PKCS1_SIG = { sha256: "sha256WithRSAEncryption", sha384: "sha384WithRSAEncryption", sha512: "sha512WithRSAEncryption" };
|
package/lib/tsp-sign.js
CHANGED
|
@@ -47,7 +47,7 @@ var _b = pkiBuild.makeBuilder({
|
|
|
47
47
|
NAME_SCHEMA: pkix.name(_NS), SPKI_SCHEMA: pkix.spki(_NS),
|
|
48
48
|
});
|
|
49
49
|
|
|
50
|
-
var NODE_DIGEST = { sha256: "sha256", sha384: "sha384", sha512: "sha512" };
|
|
50
|
+
var NODE_DIGEST = intrinsic.assign(intrinsic.create(null), { sha256: "sha256", sha384: "sha384", sha512: "sha512" });
|
|
51
51
|
var HASH_LEN = { sha256: 32, sha384: 48, sha512: 64 };
|
|
52
52
|
|
|
53
53
|
var _REVOCATION_RANK = { "false": 0, "undetermined": 1, "waived": 2, "determined": 3 };
|
|
@@ -397,9 +397,9 @@ function response(token, opts) {
|
|
|
397
397
|
function parseResponse(input) { return schemaTsp.parse(input); }
|
|
398
398
|
|
|
399
399
|
|
|
400
|
-
var _VERIFY_DIGEST = { sha256: "sha256", sha384: "sha384", sha512: "sha512", sha1: "sha1" };
|
|
401
|
-
var _VERIFY_DIGEST_LEN = { sha1: 20, sha256: 32, sha384: 48, sha512: 64 };
|
|
402
|
-
var _BIND_DIGEST = { sha256: "sha256", sha384: "sha384", sha512: "sha512" };
|
|
400
|
+
var _VERIFY_DIGEST = intrinsic.assign(intrinsic.create(null), { sha256: "sha256", sha384: "sha384", sha512: "sha512", sha1: "sha1" });
|
|
401
|
+
var _VERIFY_DIGEST_LEN = intrinsic.assign(intrinsic.create(null), { sha1: 20, sha256: 32, sha384: 48, sha512: 64 });
|
|
402
|
+
var _BIND_DIGEST = intrinsic.assign(intrinsic.create(null), { sha256: "sha256", sha384: "sha384", sha512: "sha512" });
|
|
403
403
|
|
|
404
404
|
function _imprintMatches(mi, data) {
|
|
405
405
|
var name = mi.hashAlgorithm && mi.hashAlgorithm.name;
|
package/lib/webcrypto.js
CHANGED
|
@@ -122,7 +122,7 @@ function _normalizeAlg(algorithm, who) {
|
|
|
122
122
|
return out;
|
|
123
123
|
}
|
|
124
124
|
|
|
125
|
-
var _STD_ALG_NAME = { "RSASSA-PKCS1-V1_5": "RSASSA-PKCS1-v1_5", "ED25519": "Ed25519", "ED448": "Ed448" };
|
|
125
|
+
var _STD_ALG_NAME = intrinsic.assign(intrinsic.create(null), { "RSASSA-PKCS1-V1_5": "RSASSA-PKCS1-v1_5", "ED25519": "Ed25519", "ED448": "Ed448" });
|
|
126
126
|
function _stdName(name) { return _STD_ALG_NAME[name] || name; }
|
|
127
127
|
|
|
128
128
|
var HASH_NODE = {
|
|
@@ -164,24 +164,24 @@ function _hmacLengthBits(alg, who) {
|
|
|
164
164
|
return alg.length;
|
|
165
165
|
}
|
|
166
166
|
|
|
167
|
-
var CURVE_NODE = { "P-256": "prime256v1", "P-384": "secp384r1", "P-521": "secp521r1" };
|
|
168
|
-
var CURVE_FIELD_BYTES = { "P-256": 32, "P-384": 48, "P-521": 66 };
|
|
167
|
+
var CURVE_NODE = intrinsic.assign(intrinsic.create(null), { "P-256": "prime256v1", "P-384": "secp384r1", "P-521": "secp521r1" });
|
|
168
|
+
var CURVE_FIELD_BYTES = intrinsic.assign(intrinsic.create(null), { "P-256": 32, "P-384": 48, "P-521": 66 });
|
|
169
169
|
|
|
170
|
-
var ML_DSA_NODE = { "ML-DSA-44": "ml-dsa-44", "ML-DSA-65": "ml-dsa-65", "ML-DSA-87": "ml-dsa-87" };
|
|
171
|
-
var ML_KEM_NODE = { "ML-KEM-512": "ml-kem-512", "ML-KEM-768": "ml-kem-768", "ML-KEM-1024": "ml-kem-1024" };
|
|
170
|
+
var ML_DSA_NODE = intrinsic.assign(intrinsic.create(null), { "ML-DSA-44": "ml-dsa-44", "ML-DSA-65": "ml-dsa-65", "ML-DSA-87": "ml-dsa-87" });
|
|
171
|
+
var ML_KEM_NODE = intrinsic.assign(intrinsic.create(null), { "ML-KEM-512": "ml-kem-512", "ML-KEM-768": "ml-kem-768", "ML-KEM-1024": "ml-kem-1024" });
|
|
172
172
|
|
|
173
|
-
var SLH_DSA_NODE =
|
|
173
|
+
var SLH_DSA_NODE = intrinsic.create(null);
|
|
174
174
|
["sha2-128s", "sha2-128f", "sha2-192s", "sha2-192f", "sha2-256s", "sha2-256f",
|
|
175
175
|
"shake-128s", "shake-128f", "shake-192s", "shake-192f", "shake-256s", "shake-256f"
|
|
176
176
|
].forEach(function (s) { SLH_DSA_NODE["SLH-DSA-" + _toUpperCase(s)] = "slh-dsa-" + s; });
|
|
177
177
|
|
|
178
|
-
var SIGN_VERIFY_NAMES =
|
|
178
|
+
var SIGN_VERIFY_NAMES = intrinsic.create(null);
|
|
179
179
|
["RSASSA-PKCS1-V1_5", "RSA-PSS", "ECDSA", "ED25519", "ED448", "HMAC"]
|
|
180
180
|
.concat(_keys(ML_DSA_NODE), _keys(SLH_DSA_NODE))
|
|
181
181
|
.forEach(function (n) { SIGN_VERIFY_NAMES[n] = true; });
|
|
182
|
-
var ENCRYPT_DECRYPT_NAMES = { "RSA-OAEP": true, "AES-GCM": true, "AES-CBC": true, "AES-CTR": true };
|
|
183
|
-
var DERIVE_NAMES = { "ECDH": true, "X25519": true, "X448": true, "HKDF": true, "PBKDF2": true, "X963KDF": true };
|
|
184
|
-
var SECRET_KEY_NAMES = { "AES-GCM": true, "AES-CBC": true, "AES-CTR": true, "AES-KW": true, "HMAC": true, "HKDF": true, "PBKDF2": true, "X963KDF": true };
|
|
182
|
+
var ENCRYPT_DECRYPT_NAMES = intrinsic.assign(intrinsic.create(null), { "RSA-OAEP": true, "AES-GCM": true, "AES-CBC": true, "AES-CTR": true });
|
|
183
|
+
var DERIVE_NAMES = intrinsic.assign(intrinsic.create(null), { "ECDH": true, "X25519": true, "X448": true, "HKDF": true, "PBKDF2": true, "X963KDF": true });
|
|
184
|
+
var SECRET_KEY_NAMES = intrinsic.assign(intrinsic.create(null), { "AES-GCM": true, "AES-CBC": true, "AES-CTR": true, "AES-KW": true, "HMAC": true, "HKDF": true, "PBKDF2": true, "X963KDF": true });
|
|
185
185
|
|
|
186
186
|
|
|
187
187
|
/**
|
|
@@ -974,12 +974,12 @@ function _importRawPublic(name, alg, raw, extractable, usages) {
|
|
|
974
974
|
throw new WebCryptoError("webcrypto/not-supported", "importKey raw: unsupported public-key algorithm " + _stringify(name));
|
|
975
975
|
}
|
|
976
976
|
|
|
977
|
-
var IMPORT_KEY_TYPE = {
|
|
977
|
+
var IMPORT_KEY_TYPE = intrinsic.assign(intrinsic.create(null), {
|
|
978
978
|
"RSASSA-PKCS1-V1_5": { rsa: 1 }, "RSA-PSS": { rsa: 1, "rsa-pss": 1 }, "RSA-OAEP": { rsa: 1 },
|
|
979
979
|
"ECDSA": { ec: 1 }, "ECDH": { ec: 1 },
|
|
980
980
|
"ED25519": { ed25519: 1 }, "ED448": { ed448: 1 },
|
|
981
981
|
"X25519": { x25519: 1 }, "X448": { x448: 1 },
|
|
982
|
-
};
|
|
982
|
+
});
|
|
983
983
|
[ML_DSA_NODE, ML_KEM_NODE, SLH_DSA_NODE].forEach(function (m) {
|
|
984
984
|
_forEach(_keys(m), function (webName) { var t = {}; t[m[webName]] = 1; IMPORT_KEY_TYPE[webName] = t; });
|
|
985
985
|
});
|
package/package.json
CHANGED
package/sbom.cdx.json
CHANGED
|
@@ -2,10 +2,10 @@
|
|
|
2
2
|
"$schema": "http://cyclonedx.org/schema/bom-1.5.schema.json",
|
|
3
3
|
"bomFormat": "CycloneDX",
|
|
4
4
|
"specVersion": "1.5",
|
|
5
|
-
"serialNumber": "urn:uuid:
|
|
5
|
+
"serialNumber": "urn:uuid:ba3e8f6b-69f8-4691-b5ee-3d227fe61113",
|
|
6
6
|
"version": 1,
|
|
7
7
|
"metadata": {
|
|
8
|
-
"timestamp": "2026-09-
|
|
8
|
+
"timestamp": "2026-09-01T20:36:49.754Z",
|
|
9
9
|
"lifecycles": [
|
|
10
10
|
{
|
|
11
11
|
"phase": "build"
|
|
@@ -19,14 +19,14 @@
|
|
|
19
19
|
}
|
|
20
20
|
],
|
|
21
21
|
"component": {
|
|
22
|
-
"bom-ref": "@blamejs/pki@0.6.
|
|
22
|
+
"bom-ref": "@blamejs/pki@0.6.21",
|
|
23
23
|
"type": "application",
|
|
24
24
|
"name": "pki",
|
|
25
|
-
"version": "0.6.
|
|
25
|
+
"version": "0.6.21",
|
|
26
26
|
"scope": "required",
|
|
27
27
|
"author": "blamejs contributors",
|
|
28
28
|
"description": "Pure-JavaScript PKI toolkit that owns its stack — X.509, ASN.1/DER, CMS, PQC-first.",
|
|
29
|
-
"purl": "pkg:npm/%40blamejs/pki@0.6.
|
|
29
|
+
"purl": "pkg:npm/%40blamejs/pki@0.6.21",
|
|
30
30
|
"properties": [],
|
|
31
31
|
"externalReferences": [
|
|
32
32
|
{
|
|
@@ -54,7 +54,7 @@
|
|
|
54
54
|
"components": [],
|
|
55
55
|
"dependencies": [
|
|
56
56
|
{
|
|
57
|
-
"ref": "@blamejs/pki@0.6.
|
|
57
|
+
"ref": "@blamejs/pki@0.6.21",
|
|
58
58
|
"dependsOn": []
|
|
59
59
|
}
|
|
60
60
|
]
|